<?php

/**
 * Plugin Name: Davsy
 * Plugin URI: https://cipl.net.in/
 * Description: Davsy
 * Version: 1.0
 * Author: Corporate Infocom Private Limited
 * Author URI: https://cipl.net.in/
 * @package Davsy
 * Text Domain: wp-davsy
 */
// Direct access not allowed.

if ( ! defined( 'ABSPATH' ) ) {
    exit;
}
/**
 * WP_Davsy class.
 */
class WP_Davsy {
    public $admin_notices;
    /**
     * construct function.

     */
    public function __construct() {
        // Define constants WP_DAVSY
        define( 'WP_DAVSY_PLUGIN_VERSION', '1.0' );
        define( 'WP_DAVSY_PLUGIN_DOMAIN', 'wp-davsy' );
        define( 'WP_DAVSY_PLUGIN_URL', WP_PLUGIN_URL . '/davsy' );
        define( 'WP_DAVSY_CORE_DIR', WP_PLUGIN_DIR . '/davsy' );
        define( 'WP_DAVSY_LANGUAGES_DIR', WP_DAVSY_CORE_DIR . '/languages' );
        define( 'WP_DAVSY_INCLUDES_DIR', WP_DAVSY_CORE_DIR . '/includes' );
        $this->admin_notices = array();
		 
       // Initialize Addon
        add_action( 'init', array( $this, 'init' ) );
		 
		
		
		/*  */
        require_once ( WP_DAVSY_INCLUDES_DIR . '/class-davsy-widget.php' );
		require_once ( WP_DAVSY_INCLUDES_DIR . '/class-wp-davsy-api.php' ); 
		
		
		 add_action( 'widgets_init', array($this, 'register_davsy_widget'));
		 
       add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), array($this,'wp_davsy_settings_plugin_links' ));
			$this->settings = new stdClass();
            $this->settings->davsy_api_key = get_option("davsy_api_key");
			$this->settings->wp_davsy_widget_enabled = get_option("wp_davsy_widget_enabled");
			
	}

public function wp_davsy_settings_plugin_links($links){
	 $links[] =  '<a href="' . admin_url( '?page=davsy-setting' ).'">' . __('Settings','wp-davsy') . '</a>';
  ksort($links);
  return $links;
}

    /**

     * Initialize application, load text domain, enqueue scripts, include classes and add actions

     */

    public function init() {
      
	  /* Setting Page */
         add_action('admin_menu', array( &$this, 'wp_davsy_page' ));
		 
	 add_action('admin_enqueue_scripts', array( &$this, 'wp_davsy_admin_script' ));
	 add_action('wp_enqueue_scripts', array( &$this, 'wp_davsy_front_script' ));
	 
	 add_filter('the_content', array(&$this, 'wp_davsy_below_article_widget_content'), 8);
   
   }
   

/* Davsy Admin Scripts */
public function wp_davsy_admin_script(){
	 wp_register_script( 'wp_davsy_admin', WP_DAVSY_PLUGIN_URL. '/assets/js/wp_davsy_admin.js', false, '1.3' );
     wp_enqueue_script( 'wp_davsy_admin' );
}

/* Davsy Admin Scripts */
public function wp_davsy_front_script(){
	 wp_register_script( 'wp_davsy_front', WP_DAVSY_PLUGIN_URL. '/assets/js/wp_davsy_front.js', false, '1.3' );
     wp_enqueue_script('wp_davsy_front');
	 
	 wp_enqueue_style( 'wp_davsy_front', WP_DAVSY_PLUGIN_URL.'/assets/css/wp_davsy_front.css',time(), false );
}

   /**

     * Add admin menu page wp_davsy_settings 

     * */

    public function wp_davsy_page() {
		
       add_menu_page('Davsy Setting', 'Davsy Setting', 'manage_options', 'davsy-setting', array( &$this, 'wp_davsy_settings' ));
    }

/**
 * wp davsy settings page
 * */

    public function wp_davsy_settings() {
	?>
	<div id="wrapper" class="wrap theme-wrap custom-bg-color">
	 <h2><?php echo esc_html__( 'Davsy Setting Page', 'wp-davsy' ); ?></h2>
	 <?php
if (isset($_POST['davsy_field']) ||  wp_verify_nonce($_POST['davsy_field'], 'davsy_action')) 
 {
	$davsy_api_key=$davsy_no_post=$davsy_header_title=$wp_davsy_widget_enabled='';
	if( isset($_POST['davsy_api_key']) ){
        $davsy_api_key = sanitize_text_field($_POST['davsy_api_key']);
	}
	if( isset($_POST['wp_davsy_widget_enabled']) ){
        $wp_davsy_widget_enabled = sanitize_text_field($_POST['wp_davsy_widget_enabled']);
	}
	if( isset($_POST['davsy_header_title']) ){
        $davsy_header_title = sanitize_text_field($_POST['davsy_header_title']);
	}
	if( isset($_POST['davsy_no_post']) ){
        $davsy_no_post = sanitize_text_field($_POST['davsy_no_post']);
		if(!is_numeric($davsy_no_post)) {
			$davsy_no_post='';
		}
	}
	update_option('davsy_api_key',$davsy_api_key);
	update_option('wp_davsy_widget_enabled',$wp_davsy_widget_enabled);
	update_option('davsy_header_title',$davsy_header_title);
	update_option('davsy_no_post',$davsy_no_post);
	?>
	<div class="updated" id="success_msg"><p><strong><?php _e( 'Your data has been successfully Save.', 'wp-davsy' ); ?></strong></p></div>
	<?php
	
}   
     $davsy_api_key=(get_option('davsy_api_key'));
     $wp_davsy_widget_enabled=(get_option('wp_davsy_widget_enabled'));
	 $davsy_no_post=(get_option('davsy_no_post'));
	 $davsy_header_title=(get_option('davsy_header_title'));
	 
	 ?>
     <form id="wp-davsy-setting" class="wp-davsy" method="post" action="" enctype="multipart/form-data">
	 <?php wp_nonce_field( 'davsy_action', 'davsy_field' ); ?>
         
		<table class="wp-list-table widefat" style="margin-top: 25px;" cellpadding="0" cellspacing="0">
		<tr>
		<th width="30%"><?php echo esc_html__( 'Website Api Key', 'wp-davsy' ); ?></th>
		<td width="70%"><input style="width:80%" type="text" value="<?php echo $davsy_api_key;?>" id="davsy_api_key" name="davsy_api_key"></td>
		</tr>
		<tr>
		<th colspan="2"><h2><?php echo esc_html__( 'Important Information!', 'wp-davsy' ); ?></h2></th>
		</tr>
		<tr>
		<td colspan="2">
                   <?php echo esc_html__( 'Get your website key from your Davsy', 'wp-davsy' ); ?> 
                    <a  href="https://app.davsy.com/" target="_blank"> dashboard</a><br>
					
                    Don't have an account yet? Sign up for one
                    <a  href="https://app.davsy.com/register" target="_blank">here</a>
             </td>
            </tr>
			<tr>
		<td colspan="2">
			<hr style="margin-bottom:25px; margin-top:5px;">
			</td></tr>
		<tr>
		<td><input type="checkbox" name="wp_davsy_widget_enabled" <?= $wp_davsy_widget_enabled == '1' ? 'checked="checked"' : ''; ?> value="1"></td>
		<td><span> Below The Article Widget </span></td>
		</tr>
<tr>
		
		<th><?php echo esc_html__( 'Header Title', 'wp-davsy' ); ?></th>
		<td><input style="width:80%" type="text" value="<?php echo $davsy_header_title;?>" id="davsy_header_title" name="davsy_header_title">
		</td>
		</tr>		
		<tr>
		<td><p class="submit"><input type="submit" name="submit" id="wp_davsy_submit" class="button button-primary" value="Submit"></p></td>
		<td></td>
		</tr>
		</table>   
		</form>

        </div>

        <?php

    }
	public function register_davsy_widget(){
		 register_widget( 'Wp_Davsy_Widget' );
	}
	
	function has_added_davsy_website_key() {
	return isset($this->settings->davsy_api_key) && strlen(trim($this->settings->davsy_api_key)) > 17;
	}
	
	  public function should_show_below_article_widget()
        {
			
            $retVal = ( $this->has_added_davsy_website_key() && is_single());
            return $retVal;
        }
		
	function wp_davsy_below_article_widget_content($content)
        {
			if ( $this->should_show_below_article_widget() ) {
		$davsy_obj='';
	    $wp_davsy_widget_enabled=trim( get_option('wp_davsy_widget_enabled'));
		if(isset($wp_davsy_widget_enabled) && $wp_davsy_widget_enabled=='1'){
	    $davsy_header_title=trim( get_option('davsy_header_title'));
	    $davsy_api_key=trim( get_option('davsy_api_key') );
		$no_post=4;
		
		if(!empty($davsy_api_key) && strlen($davsy_api_key)>='17'){
			$app_data= Wp_Davsy_API::get_davsy_posts();
			//print_r($app_data);
		if(!empty($app_data['result']) && is_array($app_data['result'])){
			$coloClass='davsy-col-'.$no_post;
		$davsy_obj .="<div class='davsy-main-widget $coloClass'>";
		$davsy_obj .= "<h2>".$davsy_header_title."</h2>";
		$davsy_obj .="<ul class='davsy-widget'>";
		$i=1;
		foreach($app_data['result'] as $key=>$widget_value){
			$pids[]=$widget_value->id;
			$widget_img=$widget_value->blog_post_image;
			$widget_link=$widget_value->blog_post_url;
			$widget_title=$widget_value->blog_post_title;
			$davsy_obj .= '<li><a class="wp_davsy_link" target="_blank" data-href="'.$widget_link.'"><span class="davsy-img-block" style="background-image: url('.$widget_img.')"></span><span>'.$widget_title.'</span></a></li>';
			if($no_post==$i)
			{
				break;
			}
			$i++;
		}
		Wp_Davsy_API::updateDavsyPostsviewCount(json_encode($pids));
		$davsy_obj .= "</ul>";
		$davsy_obj .= "<div class='davsy-powered'><ul><li class='powered-text'><span>Powered By: </span></li><li class='powered-logo'><a href='https://davsy.com/' target='_blank'><img src='https://app.davsy.com:443/assets/images/davsy-logo.png'></a></li></ul></div>";
		$davsy_obj .= "</div>";
		}else{
			$davsy_obj .= "<div class='davsy-main-widget'>";
			$davsy_obj .= '<p class="key_error">'.esc_html__( 'Something Wrong Please Contact to Davsy Admin', 'wp-davsy' ).'</p>';
			$davsy_obj .= "</div>";
		}
		
				$content = $content . $davsy_obj;
            }
			}
			}
            return $content;
        }
	
	
	
	
	
}
new WP_Davsy();
function activate_wp_davsy(){
$slug = get_option('wp_davsy');
if(!$slug) update_option('wp_davsy', 'davsy');
        
}
function deactivate_wp_davsy(){
	delete_option('wp_davsy');
	delete_option('davsy_api_key');
	delete_option('davsy_no_post');
	delete_option('davsy_header_title');
    flush_rewrite_rules();
}

//activate plugin	   
register_activation_hook( __FILE__, 'activate_wp_davsy' );
//deactivate plugin
register_deactivation_hook( __FILE__, 'deactivate_wp_davsy' );