<?php
// Direct access not allowed.
if (!defined('ABSPATH')) {
    exit;
}

/**
 * Wp_Davsy_Widget
 */

class Wp_Davsy_Widget extends WP_Widget{
/**
	 * Register widget with WordPress.
	 */
	
	function __construct() {
		parent::__construct(
			'davsy_widget', 
			esc_html__( 'Davsy Blog Post', 'wp-davsy' ), // Name
			array( 'description' => esc_html__( 'A Davsy Blog Post Widget', 'wp-davsy' ), ) // Args
			
			
		);
		// Initialize Addon
        
		 require_once ( WP_DAVSY_INCLUDES_DIR . '/class-wp-davsy-api.php' ); 
	}

	/**
	 * Front-end display of widget.
	 
	 */
	public function widget( $args, $instance ) {
		echo "<div class='davsy_sidebar'>";
		 echo $args['before_widget'];
		 
		 $no_post=4;
		 $davsy_header_title=$instance['header'];
		 $davsy_api_key=trim( get_option('davsy_api_key') );
		
		if(!empty($davsy_api_key) && strlen($davsy_api_key)>='17'){
		
		$app_data= Wp_Davsy_API::get_davsy_posts();
		
		if(!empty($app_data['result']) && is_array($app_data['result'])){
			
		echo "<div class='davsy-main-widget'>";
		echo "<h2>".$davsy_header_title."</h2>";
		echo "<ul class='davsy-widget'>";
		$i=1;
		
		foreach($app_data['result'] as $key=>$widget_value){
			$pids[]=$widget_value->id;
			$widget_img=$widget_value->blog_post_image;
			$widget_link=$widget_value->blog_post_url;
			$widget_title=$widget_value->blog_post_title;
			echo '<li><a class="wp_davsy_link" target="_blank" data-href="'.$widget_link.'"><span class="davsy-img-block" style="background-image: url('.$widget_img.')"></span><span>'.$widget_title.'</span></a></li>';
			if($no_post==$i)
			{
				break;
			}
			$i++;
		}
		
		Wp_Davsy_API::updateDavsyPostsviewCount(json_encode($pids));
		echo "</ul>";
		echo "<div class='davsy-powered'><ul><li class='powered-text'><span>Powered By: </span></li><li class='powered-logo'><a href='https://davsy.com/' target='_blank'><img src='https://app.davsy.com:443/assets/images/davsy-logo.png'></a></li></ul></div>";
		echo "</div>";
		}else{
			echo "<div class='davsy-main-widget'>";
			echo '<p class="key_error">'.esc_html__( 'Something Wrong Please Contact to Davsy Admin', 'wp-davsy' ).'</p>';
			echo "</div>";
		}
		
		}else{
			echo "<div class='davsy-main-widget'>";
			echo '<p class="key_error">'.esc_html__( 'Please Enter Key in Davsy Setting Page', 'wp-davsy' ).'</p>';
			echo "</div>";
		}
		
		echo $args['after_widget'];
		echo "</div>";
	}

	/**
	 * Back-end widget form.
	
	 */
	public function form( $instance ) {
		$header = ! empty( $instance['header'] ) ? $instance['header'] : esc_html__( 'Partner Posts', 'wp-davsy');
		$no_post = 4;
		?>
		
		
		<p>
			<label for="<?php echo esc_attr( $this->get_field_id( 'header' ) ); ?>"><?php esc_attr_e( 'Header:', 'wp-davsy' ); ?></label> 
			<input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'header' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'header' ) ); ?>" type="text" value="<?php echo esc_attr( $header ); ?>">
		</p>
		
		<?php 
	}

	/**
	 * Sanitize widget form values as they are saved.
	 *
	
	 */
	public function update( $new_instance, $old_instance ) {
		$instance = array();
		$instance['header'] = ( ! empty( $new_instance['header'] ) ) ? sanitize_text_field( $new_instance['header'] ) : '';
		

		return $instance;
	}

}
