<?php
// Direct access not allowed.
if (!defined('ABSPATH')) {
    exit;
}

/**
 * Wp_Davsy_API
 */

class Wp_Davsy_API{
    /**
     * Get posts from the davsy API
     * @return array()
    */

    public static function get_davsy_posts($args=array()) {

	// default davsy api arguments
	$davsy_api_key=trim( get_option('davsy_api_key') );
		 
        $default_args = array(
		     'key' => $davsy_api_key,
             'noofposts' =>'4',
             'order' => 'DESC',
             'rand' => 1
			 );

        $endpoint = "https://app.davsy.com/blog_posts?";
		$args = wp_parse_args( $args, $default_args );
        $results = array();
       $result = wp_remote_get( $endpoint . http_build_query($args, '', '&') );
	   
        if (!is_wp_error($result) && !empty($result['body'])) {
            $results = (array) json_decode($result['body']);
        }
        return isset($results['results']) ? $results['results'] : $results;

    }
	
	public static function updateDavsyPostsviewCount($requestJson) {
		$postUrl = 'https://app.davsy.com/views_update';
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL,$postUrl);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS,
		"pids=".$requestJson);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$response = curl_exec ($ch);
		curl_close ($ch);
		return $response;
	}

}